

let g =
  [|
    [|1;0;0;0;0;1;1|];
    [|0;1;0;0;1;0;1|];
    [|0;0;1;0;1;1;0|];
    [|0;0;0;1;1;1;1|]
  |]

let h =
  [|
    [|0;0;0;1;1;1;1|];
    [|0;1;1;0;0;1;1|];
    [|1;0;1;0;1;0;1|]
  |]



let encode_col v m k =
  let dim = Array.length v in
  let vm = Array.init dim (fun n -> v.(n) * m.(n).(k)) in
  (Array.fold_left (+) 0 vm) mod 2

let encode len word =
  Array.init len (encode_col word g)


let syndrome_col v m k =
  let dim = Array.length v in
  let vm = Array.init dim (fun n -> v.(n) * m.(k).(n)) in
  (Array.fold_left (+) 0 vm) mod 2

let syndrome len codeword =
  Array.init len (syndrome_col codeword h)

