
let prob () = if (Random.int 2) = 1 then 1 else -1

let random_walk pfunc n =
  let x_arr = Array.make n 0 in
  let rec position x_arr n_cur =
    x_arr.(n_cur) <- (x_arr.(n_cur-1)) + (pfunc ());
    print_endline (string_of_int x_arr.(n_cur));
    let n_next = n_cur + 1 in
    if n_next >= n then x_arr
    else position x_arr n_next
  in
  position x_arr 1

let () =
  Random.self_init ();
  let x_arr = random_walk prob 20 in
  ()
